Attribute VB_Name = "Registry"
' API Function Declares
Option Explicit

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_CURRENT_CONFIG = &H80000005
Public Const HKEY_DYN_DATA = &H80000006

Public Const REG_NONE = 0
Public Const REG_SZ = 1
Public Const REG_EXPAND_SZ = 2
Public Const REG_BINARY = 3
Public Const REG_DWORD = 4
Public Const REG_DWORD_BIG_ENDIAN = 5
Public Const REG_MULTI_SZ = 7

Public Const KEY_EVENT = &H1
Public Const KEY_NOTIFY = &H10
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_SET_VALUE = &H2
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_CREATE_LINK = &H20
Private Const KEY_ALL_ACCESS = &H3F
Private Const READ_CONTROL = &H20000
Private Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Private Const SYNCHRONIZE = &H100000
Public Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Public Const KEY_EXECUTE = (KEY_READ)
'Public Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))

Public Const ERROR_SUCCESS = 0&
Public Const ERROR_BADDB = 1009&
Public Const ERROR_BADKEY = 1010&
Public Const ERROR_CANTOPEN = 1011&
Public Const ERROR_CANTREAD = 1012&
Public Const ERROR_CANTWRITE = 1013&
Public Const ERROR_REGISTRY_RECOVERED = 1014&
Public Const ERROR_REGISTRY_CORRUPT = 1015&
Public Const ERROR_REGISTRY_IO_FAILED = 1016&
Public Const ERROR_NOT_REGISTRY_FILE = 1017&
Public Const ERROR_KEY_DELETED = 1018&
Public Const ERROR_NO_LOG_SPACE = 1019&
Public Const ERROR_KEY_HAS_CHILDREN = 1020&
Public Const ERROR_CHILD_MUST_BE_VOLATILE = 1021&
Public Const ERROR_RXACT_INVALID_STATE = 1369&

Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" (ByVal hKey As Long, ByVal lpClass As String, lpcbClass As Long, lpReserved As Long, lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, lpcbMaxClassLen As Long, lpcValues As Long, lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, lpftLastWriteTime As FILETIME) As Long
Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As String, ByRef lpcbData As Long) As Long

Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long

'Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
'Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
'Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegSetValue Lib "advapi32.dll" Alias "RegSetValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Public Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long


Public Sub SaveToLocalMachine(ByVal i_sAppName As String, _
                              ByVal i_sSection As String, _
                              ByVal i_sKey As String, _
                              ByVal i_sSetting As String)
    Dim hKey As Long
    Dim lResult As Long
    
    On Error GoTo errHandler
    
    lResult = RegCreateKey(HKEY_LOCAL_MACHINE, "Software\" & i_sAppName & "\" & i_sSection, hKey)
    
    If lResult = 0 Then
        lResult = RegSetValueEx(hKey, i_sKey, 0, REG_SZ, ByVal i_sSetting, LenB(StrConv(i_sSetting, vbFromUnicode)) + 1)
        If lResult = 0 Then
            'save okay, do nothing here
        Else
            Debug.Assert 0
        End If
    Else
        Debug.Assert 0
    End If
    
    RegCloseKey hKey
    Exit Sub
errHandler:
    Debug.Assert 0
'    MsgBox Err.Description, , Err.Number
    
End Sub

Public Function GetFromLocalMachine(ByVal i_sAppName As String, _
                                    ByVal i_sSection As String, _
                                    ByVal i_sKey As String, _
                                    Optional ByVal i_sDefault As Variant = "") As String
    Dim hKey As Long
    Dim lResult As Long
    Dim lType As Long
    Dim lLen As Long
    Dim sValue As String
    
    On Error GoTo errHandler
    
    GetFromLocalMachine = CStr(i_sDefault)
    
    lResult = RegCreateKey(HKEY_LOCAL_MACHINE, "Software\" & i_sAppName & "\" & i_sSection, hKey)
    
    If lResult = 0 Then
        lLen = 1024
        sValue = String(lLen, Chr(0))
        lResult = RegQueryValueEx(hKey, i_sKey, 0, lType, ByVal sValue, lLen)
        If lResult = 0 Then
            Select Case lType
            Case REG_SZ
                sValue = Left(sValue, InStr(sValue, Chr(0)) - 1)
                GetFromLocalMachine = sValue
            Case Else
                Debug.Assert 0
            End Select
        Else
'            Debug.Assert 0
        End If
    Else
        Debug.Assert 0
    End If
    
    RegCloseKey hKey
    
    Exit Function
errHandler:
    Debug.Assert 0
'    MsgBox Err.Description, , Err.Number
    
End Function



